\documentclass[a4paper,10pt]{article}

\begin{document}

\title{\textbf{Loggers}}
\author{Pawel Dziepak}
\date{\textit{January 09, 2009}}
\maketitle

\section{Description}
\paragraph{}Loggers are services that can be used by other parts of the system
to notice user about any event that happened. Each information that can make
it easier to find the source of a possible bug should be sent to a logger. When
a message is passed to the logger, it decides if the information is worth printing
on the console. That helps keeping logs outputs easy to read and not flooded by
not important repeating messages. The decision is mainly based on the level
of the message which is also passed to the logger. Additionally some loggers
might ignore message if it is the same as the previously logged one.
Below, there is a list of all seven levels of importance:
\begin{itemize}
	\item{\texttt{log\_critical},}
	\item{\texttt{log\_failure},}
	\item{\texttt{log\_error},}
	\item{\texttt{log\_warning},}
	\item{\texttt{log\_alert},}
	\item{\texttt{log\_info},}
	\item{\texttt{log\_debug}.}
\end{itemize}
\paragraph{}Messages marked as \texttt{log\_critical} are always sent to the main
logger's data output. Sending information with this level from loops or any other
repeatedly executed parts of code is \textit{highly unreccomennded}. The second
level \texttt{log\_failure} is very similar to the highest one, but logger performs
checks if messages are repeating. This is a good level to choos for important messages
sent from loops. These two levels are not available for user level modules.
\paragraph{}When message level is \texttt{log\_error}, \texttt{log\_warning} or \texttt{log\_alert}
the decision of the logger depends on its characteristic and current system
state. More information about rules that loggers follow in deciding if message
can be sent to the primary data output can be found in their documentation.
\paragraph{}Messages marked as \texttt{log\_info} are always sent to the
secondary data output while messages with level \texttt{log\_debug} are
processed only if the system was compiled with an \texttt{DEBUG} option enabled.

\section{Data outputs}
\paragraph{}Loggers usually uses two data outputs, messages that logger decided to be
important are sent to the main, rest of them goes to the secondary one. In
most cases the main data output is a device (for example screen, serial port),
while the secondary data output is a file where logs are saved. However it depends on
the logger and may vary.

\section{Types of loggers}

\subsection{Early logger}
\paragraph{}Early logger is used between the start of the kernel and starting tty logger. It directly
uses device drives, and do not need any other system feature to work. Other
circumstances when it can be used is a situation when a fatal kernel error occured
and there is risk that a message informing user might not be shown if higher-level
procedures are used.

\subsection{TTY logger}
\paragraph{}TTY logger is a default system logger. It shows important messages on
the screen and sents diagnostic ones to the serial port. This logger does not perform
repeating messages check.

\include{foot}

\end{document}
